/*
    Modes:
    zero => g = 0, so result is max(...) + 1
    no   => g < max, so result is -1
    ok   => g >= max, so result is pithy
*/

#include "testlib.h"
#include <iostream>
#include <sstream>

using namespace std;

int s2i(const string &s)
{
    stringstream ss;
    ss << s;
    int x;
    ss >> x;
    return x;
}

int m;

void gen_by_delta(int delta, int &a, int &b)
{
    a = rnd.next(m - delta);
    b = a + delta;
}

int main(int argc, char *argv[])
{
    registerGen(argc, argv);

    string mode = argv[1];
    int d = s2i(argv[2]);
    m = s2i(argv[3]);

    int a1, b1, a2, b2;

    if (mode == "zero") {
        int delta = rnd.next(m);
        gen_by_delta(delta, b1, b2);
        gen_by_delta(delta, a2, a1);
    } else if (mode == "no") {
        b1 = rnd.next(m);
        b2 = rnd.next(m);
        if (b2 < b1) {
            swap(b1, b2);
        }
        int db = b2 - b1;
        if (db < m) {
            if (rnd.next(2)) {
                int delta = rnd.next(m - db);
                gen_by_delta(delta, a1, a2);
            } else {
                int delta = rnd.next(db + 1, m - 1);
                gen_by_delta(delta, a2, a1);
            }
        } else {
            int delta = rnd.next(db - m + 1, m - 1);
            gen_by_delta(delta, a2, a1);
        }
    } else if (mode == "ok") {
        b1 = rnd.next(m);
        b2 = rnd.next(m);
        if (b2 < b1) {
            swap(b1, b2);
        }
        int db = b2 - b1;
        if (db < m) {
            int delta = rnd.next(m - db, m - 1);
            gen_by_delta(delta, a1, a2);
        } else {
            if (rnd.next(2)) {
                int delta = rnd.next(m);
                gen_by_delta(delta, a1, a2);
            } else {
                int delta = rnd.next(db - m + 1);
                gen_by_delta(delta, a2, a1);
            }
        }
    }

    if (d == 1) {
        swap(a1, a2);
    }
    if (rnd.next(2)) {
        swap(b1, b2);
        swap(a1, a2);
    }
    if (rnd.next(2)) {
        swap(a1, b1);
        swap(a2, b2);
    }
    if (rnd.next(2)) {
        int shift = m - 1 - max(a1, a2);
        a1 += shift;
        a2 += shift;
    } else {
       int shift = m - 1 - max(b1, b2);
        b1 += shift;
        b2 += shift;
    }
    cout << d << endl;
    cout << a1 + 1 << endl << b1 + 1 << endl << a2 + 1 << endl << b2 + 1 << endl;

    return 0;
}
