#include "testlib.h"
#include <cctype>
using namespace std;

#define MAX_PRIME 30000
#define MAX_LEN MAX_PRIME
#define MIN_LEN 1
#define LEFT_BORDER 1
#define RIGHT_BORDER (MAX_PRIME - MIN_LEN + 1)

int prime_pref[MAX_PRIME + 1];
//amount of prime numbers on prefix [0 ; i]

void fill_primes()
{
    for (int i = 2; i <= MAX_PRIME; ++i) {
        if (prime_pref[i] == 0) {
            for (int j = i + i; j <= MAX_PRIME; j += i) {
                prime_pref[j] = 1;
            }
        }
        prime_pref[i] = prime_pref[i - 1] + !prime_pref[i];
    }
}

int main(int argc, char* argv[])
{
    fill_primes();
    registerTestlibCmd(argc, argv);
        
    int len = inf.readInt(MIN_LEN, MAX_LEN),
            quest = inf.readInt(0, len);
    int jury_ans = ans.readInt();
    if (jury_ans == -1) {
        int comp_ans = ouf.readInt();
        if (comp_ans != -1) {
            quitf(_wa, "answer is \"Impossible\" indeed");
        }
    } else {
        int left_border = ouf.readInt(LEFT_BORDER, MAX_PRIME - len + 1),
            right_border = ouf.readInt(left_border + len - 1, left_border + len - 1);
        int cnt = prime_pref[right_border] - prime_pref[left_border - 1];
        if (cnt != quest) {
            quitf(_wa, "wrong number of primes. %d insteed of %d", cnt, quest);
        }
    }
    quitf(_ok,"ok");
    return 0;
}