#include <iostream>
#include <cstdio>
#include <string>
#include <vector>
#include <algorithm>
#include <utility>
using namespace std;


#define MAX_PRIME 30000

int prime_pref[MAX_PRIME + 10];
//amount of prime numbers on prefix [0 ; i]

void fill_primes()
{
	for (int i = 2; i <= MAX_PRIME; ++i) {
		if (prime_pref[i] == 0) {
			for (int j = i + i; j <= MAX_PRIME; j += i) {
				prime_pref[j] = 1;
			}
		}
		prime_pref[i] = prime_pref[i - 1] + !prime_pref[i];
	}
}

int main(int argc, char* argv[])
{
	fill_primes();

	int len = atoi(argv[1]);
	cout << len << "\n";
	char *mode = argv[2];
	int delta = atoi(argv[3]);
	srand(delta);
	
	vector <int> cnt(len + 1);
	for (int x = 1; x + len - 1 <= MAX_PRIME; ++x) {
		++cnt[prime_pref[x + len - 1] - prime_pref[x - 1]];
	}
	int min_possible = len + 1;
	int max_possible = 0;
	for (int i = 0; i <= len; ++i) {
		if (cnt[i] != 0) {
			min_possible = min(min_possible, i);
			max_possible = max(max_possible, i);
		}
	}

	if (string(mode) == "possible") {
		cout << min_possible + rand() % (max_possible - min_possible + 1) << endl;
		return 0;
	} else if (string(mode) == "impossible") {
		if (delta > 0) {
			if (max_possible + delta > len) {
				cout << len << endl;
			} else {
				cout << max_possible + delta << endl;
			}
		} else {
			if (min_possible + delta < 0) {
				cout << 0 << endl;
			} else {
				cout << min_possible + delta << endl;
			}
		}
	} else if (string(mode) == "rare") {
		if (min_possible > max_possible)
		{
			cout << 0 << endl;
		}
		vector <pair<int,int> > non_zero;
		for (int i = min_possible; i <= max_possible; ++i) {
			non_zero.push_back(make_pair(cnt[i], i));
		}
		sort(non_zero.begin(), non_zero.end());
		delta = max(min(delta, int(non_zero.size() - 1)), 0);
		cout << non_zero[delta].second << endl;
	}
	return 0;
}
